#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;
const int base = 2;

char s[200], pr[200];
int n;

struct BigInt {
	int sz, c[200];
	void read() {
		scanf("%s", s);
		n = strlen(s);
		sz = n;
		for (int i = 0; i < 200; ++i)
			c[i] = 0;
		reverse(s, s + n);
		for (int i = 0; i < n; ++i)
			c[i] = s[i] - '0';
	}

	void null() {
		sz = 0;
		for (int i = 0; i < 200; ++i)
			c[i] = 0;
		return;
	}

	void relax() {
		for (int i = 0; i < sz; ++i) {
			c[i + 1] += c[i] / base;
			c[i] %= base;
		}
		while (c[sz] > 0) {
			c[sz + 1] += c[sz] / base;
			c[sz] %= base;
			++sz;
		}
	}

	void write(int len, int cnt) {
		for (int i = 0; i < cnt; ++i)
			pr[i] = ' ';
		for (int i = 0; i < sz; ++i)
			pr[i + cnt] = c[i] + '0';
		for (int i = cnt + sz; i < len; ++i)
			pr[i] = ' ';

		for (int i = len - 1; i >= 0; --i)
			printf("%c", pr[i]);
		puts("");
		return;
	}
};

void extra_line(int len, int cnt) {
	for (int i = len; i >= 1; --i) {
		if (i <= cnt)
			printf("-");	
		else
			printf(" ");
	}
	puts("");
	return;
}

int T;
BigInt a, b, res[50], sum;

int main()
{
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	scanf("%d\n", &T);
	for (int test = 1; test <= T; ++test) {
		a.read();
		scanf(" ");
		b.read();
		scanf("\n");

		for (int i = 0; i < b.sz; ++i) {
			res[i].null();
			res[i].sz = a.sz;

			if (b.c[i])
				for (int j = 0; j < a.sz; ++j)
					res[i].c[j] = a.c[j];
		}

		sum.null();
		sum.sz = a.sz + b.sz - 1;

		for (int i = 0; i < b.sz; ++i)
			for (int j = 0; j < a.sz; ++j)
				sum.c[i + j] += res[i].c[j];

		sum.relax();

		printf("Test %d\n", test);
		a.write(sum.sz, 0);
		b.write(sum.sz, 0);
		extra_line(sum.sz, max(b.sz, a.sz));
		for (int i = 0; i < b.sz; ++i)
			res[i].write(sum.sz, i);
		extra_line(sum.sz, sum.sz);
		int cur = sum.sz;
		while (sum.sz > 1 && sum.c[sum.sz - 1] == 0)
			sum.sz--;
		sum.write(cur, 0);
		puts("");
	} 

	return 0;
}
