#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)
#define MAXN 202
#define INF 1000000000

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

int n, m;
int d[MAXN];
vector <int> g[MAXN];
queue <int> q;

inline int bfs(int x)
{
	for (int i = 0; i < n; ++i)
		d[i] = INF;
	int res = INF;
	q.push(x);
	d[x] = 0;
	while(!q.empty())
	{
		int v = q.front();
		q.pop();
		for (int i = 0; i < sz(g[v]); ++i)
		{
			int v2 = g[v][i];
			if (d[v2] == INF)
			{
				d[v2] = d[v] + 1;
				q.push(v2);
            }
            else if (d[v2] >= d[v])
            {
//            	cout << v << ' ' << v2 << ' ' << d[v] << ' ' << d[v2] << endl;
            	res = min(res, d[v] + d[v2] + 1);
			}
		}
	}
	return res;
}

inline void solve()
{
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		g[i].clear();
	for (int i = 0; i < m; ++i)
	{
		int v1, v2;
		scanf("%d%d", &v1, &v2);
		--v1, --v2;
		g[v1].pb(v2);
		g[v2].pb(v1);
	}
	
	int ans = INF;
	for (int i = 0; i < n; ++i)
	{
		ans = min(ans, bfs(i));
    }
	printf("%d\n", ans);
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int tt;
	scanf("%d", &tt);
	for (int t = 0; t < tt; ++t)
		solve();

	return 0;
}
