#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

const ll MODULO = 2017;

ll rev[MODULO];
ll factorials[MODULO];

ll getPow(ll a, ll p) {
	ll result = 1;
	while(p != 0) {
		if((p & 1) != 0)
			result = (result * a) % MODULO;
		a = (a * a) % MODULO;
		p >>= 1;
	}
	return result;
}

ll getBits(ll mask) {
	ll result = 0;
	while(mask != 0) {
		if((mask & 1) != 0)
			++result;
		mask >>= 1;
	}
	return result;
}

int main() {
	factorials[0] = factorials[1];
	for(int i = 2; i < MODULO; i++) {
		factorials[i] = (factorials[i - 1] * i) % MODULO;
	}
	for(int i = 0; i < MODULO; i++) {
		rev[i] = getPow(i, MODULO - 2);
	}
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	for(int test = 0; test < tests; test++) {
		int n, k;
		cin >> n >> k;
		ll result = getPow(n, k);
		int total = (1 << k);
		for(int mask = 1; mask < total - 1; mask++) {
			int bits = getBits(mask);
			ll sign = (k - bits) % 2 != 0 ? -1 : 1;
			result += sign * getPow(n, bits);
			//cout << mask << " " << bits << " " << sign << endl;
		}
		result %= MODULO;
		if(result < 0) result += MODULO;
		cout << result << endl;
	}
	return 0;
}