#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

uint64_t to_uint64(string const &s) {
    uint64_t ans = 0;
    for (int i = (int) s.length(); i >= 0; --i) {
        if (s[i] == '1') {
            ans |= (1llu << (s.length() - i - 1));
        }
    }
    return ans;
}

string to_str(uint64_t x) {
    string ans;
    while (x > 0) {
        if (x & 1) {
            ans += '1';
        } else {
            ans += '0';
        }
        x >>= 1;
    }
    reverse(ans.begin(), ans.end());
    if (ans.empty()) {
        ans = "0";
    }
    return ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    int t;
    vector<string> calc;
    cin >> t;
    for (int test = 0; test < t; ++test) {
        calc.clear();
        string a, b, c;
        cin >> a >> b;
        cout << "Test " << test + 1 << endl;
        uint64_t x = to_uint64(a), y = to_uint64(b);
        c = to_str(x * y);
        calc.push_back(a);
        calc.push_back(b);
        calc.push_back(string());
        for (int i = 0; i < (int) max(a.length(), b.length()); ++i) {
            calc.back() += '-';
        }
        for (int j = (int) b.length() - 1; j >= 0; --j) {
            calc.push_back(string());
            if (b[j] == '1') {
                calc.back() += a;
            } else {
                for (int k = 0; k < (int) a.length(); ++k) {
                    calc.back() += '0';
                }
            }
            for (int k = (int) b.length() - 1; k > j; --k) {
                calc.back() += ' ';
            }
        }
        calc.push_back(string());
        for (int i = 0; i < (int) max(c.length(), calc[calc.size() - 2].length()); ++i) {
            calc.back() += '-';
        }
        calc.push_back(c);
        int l = 0;
        for (int i = 0; i < (int) calc.size(); ++i) {
            l = max(l, (int) calc[i].length());
        }
        for (int i = 0; i < (int) calc.size(); ++i) {
            //cout << "l = " << l << ", " << calc[i].length() << endl;
            for (int j = 0; j < (int) l - calc[i].length(); ++j) {
                cout << ' ';
            }
            cout << calc[i] << endl;
        }
        cout << endl;
    }
    return 0;
}
