#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


#define int li

pair<int, int> best;

void check(int a, int b) {
	while (a > 0) {
		if (a <= b && best.second > b || best.second == b && best.first > a)
			best = mp(a, b);
		b -= a;
		swap(a, b);
	}
}

void solve() {
	int n;
	cin >> n;

	best = mp(1, n);

	for (int len = 2; len < 50; ++len) {

		int l = -1, r = n;

		while (l + 1 < r) {
			int m = (l + r) / 2;

			vector<int> fib(len + 1);
			fib[len] = n;
			fib[len - 1] = m;
			bool flag = true;
			for (int i = len - 2; i >= 0; --i) {
				fib[i] = -fib[i + 1] + fib[i + 2];
				if ((i - len) % 2 == 0 && fib[i] <= 0) {
					flag = false;
					break;
				}
				if ((i - len) % 2 != 0 && fib[i] <= 0) {
					break;
				}
			}

			if (flag)
				l = m;
			else
				r = m;
		}

		if (l == -1)
			continue;

		int mx = l;

		l = 0;
		r = n;

		while (l + 1 < r) {
			int m = (l + r) / 2;

			vector<int> fib(len + 1);
			fib[len] = n;
			fib[len - 1] = m;
			bool flag = true;
			for (int i = len - 2; i >= 0; --i) {
				fib[i] = -fib[i + 1] + fib[i + 2];
				if ((i - len) % 2 != 0 && fib[i] <= 0) {
					flag = false;
					break;
				}
				if ((i - len) % 2 == 0 && fib[i] <= 0) {
					break;
				}
			}

			if (flag)
				r = m;
			else
				l = m;
		}

		if (r == n)
			continue;

		int mn = r;

		if (mn > mx)
			continue;

		check(mn, n);
		check(mx, n);

		//cout << len << ' ' << mn << ' ' << mx << "\n";


		l = mn;
		r = mx;

		while (l + 3 < r) {
			int m = (l + r) / 2;

			//cout << mn << ' '<< mx << ' ' << m << "\n";

			vector<int> fib(len + 1);
			fib[len] = n;
			fib[len - 1] = m;
			bool flag = true;
			for (int i = len - 2; i >= 0; --i) {
				fib[i] = -fib[i + 1] + fib[i + 2];
			}

			if (len % 2 == 0) {
				if (fib[0] <= fib[1])
					r = m;
				else
					l = m;
			}
			else {
				if (fib[0] <= fib[1])
					l = m;
				else
					r = m;
			}

		}

		for (int i = l; i <= r; ++i)
			check(i, n);


	}

	cout << best.first << ' ' << best.second << "\n";

}