#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int mod = 2017;

vector<vector<int>> multiply(vector<vector<int>>& q, vector<vector<int>>& w) {
	vector<vector<int>> res(q.size(), vector<int>(q.size(), 0));
	for (int i = 0; i < q.size(); ++i)
		for (int k = 0; k < q.size(); ++k)
			for (int j = 0; j < q.size(); ++j) {
				res[i][j] += q[i][k] * w[k][j];
				if (res[i][j] > 1e9)
					res[i][j] %= mod;
			}
	for (int i = 0; i < q.size(); ++i)
		for (int j = 0; j < q.size(); ++j)
			res[i][j] %= mod;
	return res;
}

void solve() {
	int n, k;
	cin >> n >> k;

	vector<vector<int>> matrix(k + 1, vector<int>(k + 1, 0));
	for (int i = 0; i <= k; ++i) {
		matrix[i][i] = i;
		if (i < k)
			matrix[i + 1][i] = 1;
	}

	vector<vector<int>> powers[32];
	powers[0] = matrix;
	for (int i = 1; i < 32; ++i) {
		powers[i] = multiply(powers[i - 1], powers[i - 1]);
	}

	vector<vector<int>> cur(k + 1, vector<int>(k + 1, 0));
	for (int i = 0; i <= k; ++i)
		cur[i][i] = 1;

	for (int z = 0; z < 31; ++z)
		if (n & (1 << z)) {
			cur = multiply(cur, powers[z]);
		}
	
	cout << cur[k][0] % mod << "\n";

}