#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
//#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int answer;
vector <vector <int> > graph;
vector <int> depth;
vector <bool> visited;

void dfs(int v, int parent, int _depth) {
  visited[v] = true;
  depth[v] = _depth;

  for (auto const &edge: graph[v]) {
    if (!visited[edge]) {
      dfs(edge, v, _depth + 1); 
    } else if (edge != parent) {
      answer = min(answer, abs(_depth - depth[edge]));
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);

  int T;
  cin >> T;
  FOR(_t, 0, T) {
    int n, m;
    cin >> n >> m;

    graph.clear();
    graph.resize(n);
    depth.clear();
    depth.resize(n);
    visited.clear();
    visited.resize(n, false);

    for (int i = 0; i != m; ++i) {
      int from, to;
      cin >> from >> to;
      --from;
      --to;

      graph[from].push_back(to);
      graph[to].push_back(from);
    }

    answer = INF;
    for (int i = 0; i != n; ++i) {
      if (!visited[i]) {
        dfs(i, -1, 0);
      }
    }
    cout << answer + 1 << '\n';
  }

  return 0;
}
