#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <queue>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int main() {
    int ts;
    scanf("%d\n", &ts);
    for (int x = 0; x < ts; x++) {

    int n, m;
    scanf("%d %d\n", &n, &m);

    vii edges;
    for (int i = 0; i < m; i++) {
        int a, b;
        scanf("%d %d\n", &a, &b);
        a--, b--;
        edges.push_back(ii(a, b));
    }

    int mn = INF;
    for (int i = 0; i < m; i++) {
        int s = edges[i].first,
            t = edges[i].second;

        vi *adj = new vi[n];
        for (int j = 0; j < m; j++) {
            if (i == j)
                continue;
            int a = edges[j].first,
                b = edges[j].second;
            adj[a].push_back(b);
            adj[b].push_back(a);
        }

        int *dist = new int[n];
        for (int j = 0; j < n;j++) {
            dist[j] = INF;
        }
        queue<int> Q;
        Q.push(s);
        dist[s] = 0;

        while (!Q.empty()) {
            int cur = Q.front();
            Q.pop();
            if (cur == t) {
                break;
            }
            for (int j = 0; j < size(adj[cur]); j++) {
                int nxt = adj[cur][j];
                if (dist[nxt] == INF) {
                    dist[nxt] = 1 + dist[cur];
                    Q.push(nxt);
                }
            }
        }

        mn = min(mn, 1 + dist[t]);
    }

    printf("%d\n", mn);

    }


    return 0;
}
