#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

long long mod = 2017;

long long egcd(long long a, ll b, ll &x, ll &y) {
    if (b == 0) { x = 1; y = 0 ; return a; }
    else {
        ll d = egcd(b, a % b, x ,y);
        x -= a / b * y;
        swap(x, y);
        return d;
    }
}

long long mod_inv(long long a, long long m) {
    long long x, y, d = egcd(a, m, x, y);
    if (d != 1) return -1;
    return x < 0 ? x + m : x;
}

long long choose(int n, int k) {
    long long res = 1;
    for (int i = 1; i <= k; i++) {
        res *= n - (k - i);
        res %= mod;
        res *= mod_inv(i, mod);
        res %= mod;
    }
    return res;
}

int main() {

    int ts;
    scanf("%d\n", &ts);
    for (int t = 0; t < ts; t++) {
        int n, k;
        scanf("%d %d\n", &n, &k);

        //cout << (choose(n - 1, k) % 2017) << endl;
        //cout << (choose(n, k) % 2017) << endl;
        cout << choose(n, k) << endl;
    }

    return 0;
}
