#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

vvi g;
int n, m;

int get(int s)
{
    vi prev(n, -1);
    vi dist(n, -1); dist[s] = 0;
    queue<int> q; q.push(s);
    while (q.size())
    {
        int u = q.front(); q.pop();
        int cur = inf;
        forn(i, g[u].size())
        {
            int v = g[u][i];
            
            if (dist[v] == -1)
            {
                dist[v] = dist[u] + 1;
                prev[v] = u;
                q.push(v);
            }
            else if (prev[u] != v)
            {
                cur = min(cur, dist[u] + dist[v] + 1);
            }
        }
        if (cur != inf)
            return cur;
    }
    return inf;
}

void solve()
{
    scanf("%d%d", &n, &m);
    g.assign(n, vi());
    forn(i, m)
    {
        int u, v; scanf("%d %d", &u, &v); --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int res = inf;
    forn(i, n)
        res = min(res, get(i));
    printf("%d\n", res);
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    int t; scanf("%d", &t);
    while (t--)
        solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif